  MEMBER
!------------------------------------------------------------------------------
  MAP
DayOfWeek            PROCEDURE(LONG nDate), BYTE ! Zero-based
GetMonthName         PROCEDURE(BYTE nMonth), STRING
WeekOfMonth          PROCEDURE(LONG nDate), BYTE ! Zero-based
  END
!------------------------------------------------------------------------------
  INCLUDE('hjCalendar.INC'),ONCE
!------------------------------------------------------------------------------
DayQueueType       QUEUE,TYPE
Control              LONG
                   END
!------------------------------------------------------------------------------
DayOfWeek PROCEDURE(LONG nDate) !, BYTE ! Zero-based
 CODE
  RETURN nDate % 7 ! 0 = Sunday; 6 = Saturday

GetMonthName PROCEDURE(BYTE nMonth) !, STRING
 CODE
  RETURN CHOOSE(nMonth, 'January', 'February', 'March',     'April',   'May',      'June', |
                        'July',    'August',   'September', 'October', 'November', 'December')

WeekOfMonth PROCEDURE(LONG nDate) !, BYTE ! Zero-based
nFirstDayOfMonth     LONG,AUTO
 CODE
  nFirstDayOfMonth = DATE(MONTH(nDate), 1, YEAR(nDate))
  nDate = nDate - nFirstDayOfMonth
  nDate = nDate + DayOfWeek(nFirstDayOfMonth)
  RETURN nDate / 7
!------------------------------------------------------------------------------
hjCalendar.GetDayControl PROCEDURE(BYTE nDayOfMonth) !, LONG ! Error returns -1
 CODE
  GET(SELF.DayQueue, nDayOfMonth)
  IF ERRORCODE()
    SELF.DayQueue.Control = -1
  END
  RETURN SELF.DayQueue.Control

hjCalendar.Init PROCEDURE(LONG nGroupControl, LONG nDate = 0) !, VIRTUAL
 CODE
  SELF.GroupControl = nGroupControl
  SELF.SelectedColor = COLOR:Green
  SELF.SelectedDate = nDate
  IF NOT SELF.SelectedDate
    SELF.SelectedDate = TODAY()
  END
  SELF.DayQueue &= NEW(DayQueueType)
  RETURN

hjCalendar.Kill PROCEDURE() !, VIRTUAL
nCount               LONG,AUTO
 CODE
  LOOP nCount = 1 TO RECORDS(SELF.DayQueue)
    GET(SELF.DayQueue, nCount)
    DESTROY(SELF.DayQueue.Control)
  END
  FREE(SELF.DayQueue)
  DISPOSE(SELF.DayQueue)
  RETURN

hjCalendar.InitializeCalendar PROCEDURE() !, PROTECTED, VIRTUAL
nControl             LONG,AUTO
nCount               LONG,AUTO
 CODE
  nControl = CREATE(0, CREATE:Box, SELF.GroupControl)
  nControl{PROP:Color} = COLOR:None
  nControl{PROP:Fill} = SELF.SelectedColor
  nControl{PROP:Hide} = False
  SELF.SelectedBoxControl = nControl
  nControl +=1

  nControl = CREATE(0, CREATE:Box, SELF.GroupControl)
  nControl{PROP:Color} = COLOR:Red
  nControl{PROP:Hide} = False
  SELF.TodayBoxControl = nControl
  nControl +=1

  nControl = CREATE(0, CREATE:Region, SELF.GroupControl)
  nControl{PROP:Hide} = False
  SELF.RegionControl = nControl
  nControl +=1

  nControl = CREATE(0, CREATE:Button, SELF.GroupControl)
  nControl{PROP:FontName} = 'Marlett'
  nControl{PROP:FontSize} = 11
  nControl{PROP:Flat} = True
  nControl{PROP:Trn} = True
  nControl{PROP:Skip} = True
  nControl{PROP:Text} = 3 ! This is a left arrow
  nControl{PROP:Hide} = False
  SELF.PrevMonthControl = nControl
  nControl += 1

  nControl = CREATE(0, CREATE:Button, SELF.GroupControl)
  nControl{PROP:Flat} = True
  nControl{PROP:Trn} = True
  nControl{PROP:Skip} = True
  nControl{PROP:Hide} = False
  SELF.MonthNameControl = nControl
  nControl += 1

  nControl = CREATE(0, CREATE:Droplist, SELF.GroupControl)
  nControl{PROP:Skip} = True
  nControl{PROP:Drop} = 7
  nControl{PROP:Height} = 0
  nControl{PROP:Hide} = False
  SELF.DropDownControl = nControl
  nControl += 1

  nControl = CREATE(0, CREATE:Button, SELF.GroupControl)
  nControl{PROP:FontName} = 'Marlett'
  nControl{PROP:FontSize} = 11
  nControl{PROP:Flat} = True
  nControl{PROP:Trn} = True
  nControl{PROP:Skip} = True
  nControl{PROP:Text} = 4 ! This is a right arrow
  nControl{PROP:Hide} = False
  SELF.NextMonthControl = nControl
  nControl += 1

  LOOP nCount = 1 TO 7
    nControl = CREATE(0, CREATE:Prompt, SELF.GroupControl)
    nControl{PROP:Trn} = True
    nControl{PROP:Center} = True
    nControl{PROP:Text} = CHOOSE(nCount, 'S', 'M', 'T', 'W', 'T', 'F', 'S')
    nControl{PROP:Hide} = False
    nControl += 1
  END

  nControl = CREATE(0, CREATE:Line, SELF.GroupControl)
  nControl{PROP:Color} = COLOR:Black
  nControl{PROP:Height} = 0
  nControl{PROP:Hide} = False
  SELF.LineControl = nControl
  nControl +=1
  RETURN

hjCalendar.RefreshCalendar PROCEDURE() !, PRIVATE
nCount               LONG,AUTO
nDate                LONG,AUTO
 CODE
  IF SELF.DayWidth <> (SELF.GroupControl{PROP:Width} / 7) OR SELF.DayHeight <> (SELF.GroupControl{PROP:Height} / 8)
    SELF.DayWidth = SELF.GroupControl{PROP:Width} / 7
    SELF.DayHeight = SELF.GroupControl{PROP:Height} / 8

    SETPOSITION(SELF.LineControl, SELF.GroupControl{PROP:Xpos}, |
                                  SELF.GroupControl{PROP:Ypos} + (SELF.DayHeight * 2), |
                                  SELF.GroupControl{PROP:Width})

    SETPOSITION(SELF.RegionControl, SELF.GroupControl{PROP:Xpos}, |
                                    SELF.GroupControl{PROP:Ypos}, |
                                    SELF.GroupControl{PROP:Width}, |
                                    SELF.GroupControl{PROP:Height})

    SETPOSITION(SELF.PrevMonthControl, SELF.GroupControl{PROP:Xpos}, |
                                       SELF.GroupControl{PROP:Ypos}, |
                                       SELF.DayWidth, |
                                       SELF.DayHeight)

    SETPOSITION(SELF.MonthNameControl, SELF.GroupControl{PROP:Xpos} + SELF.DayWidth, |
                                       SELF.GroupControl{PROP:Ypos}, |
                                       SELF.DayWidth * 5, |
                                       SELF.DayHeight)

    SETPOSITION(SELF.DropDownControl, SELF.GroupControl{PROP:Xpos} + SELF.DayWidth, |
                                      SELF.GroupControl{PROP:Ypos} - (SELF.DropDownControl{PROP:LineHeight} * 3), |
                                      SELF.DayWidth * 5)

    SETPOSITION(SELF.NextMonthControl, SELF.GroupControl{PROP:Xpos} + (SELF.DayWidth * 6), |
                                       SELF.GroupControl{PROP:Ypos}, |
                                       SELF.DayWidth, |
                                       SELF.DayHeight)

    LOOP nCount = SELF.NextMonthControl TO SELF.NextMonthControl + 6
      SETPOSITION(nCount + 1, SELF.GroupControl{PROP:Xpos} + ((nCount - SELF.NextMonthControl) * SELF.DayWidth), |
                              SELF.GroupControl{PROP:Ypos} + SELF.DayHeight, |
                              SELF.DayWidth, |
                              SELF.DayHeight)
    END

    LOOP nCount = 1 TO RECORDS(SELF.DayQueue)
      GET(SELF.DayQueue, nCount)
      nDate = DATE(MONTH(SELF.DisplayDate), nCount, YEAR(SELF.DisplayDate))
      SETPOSITION(SELF.DayQueue.Control, SELF.GroupControl{PROP:Xpos} + (DayOfWeek(nDate) * SELF.DayWidth), |
                                         SELF.GroupControl{PROP:Ypos} + ((WeekOfMonth(nDate) + 2) * SELF.DayHeight), |
                                         SELF.DayWidth, |
                                         SELF.DayHeight)
    END

    GET(SELF.DayQueue, DAY(TODAY()))
    SETPOSITION(SELF.TodayBoxControl, SELF.DayQueue.Control{PROP:Xpos}, |
                                      SELF.DayQueue.Control{PROP:Ypos}, |
                                      SELF.DayWidth, |
                                      SELF.DayHeight)

    GET(SELF.DayQueue, DAY(SELF.SelectedDate))
    SETPOSITION(SELF.SelectedBoxControl, SELF.DayQueue.Control{PROP:Xpos}, |
                                         SELF.DayQueue.Control{PROP:Ypos}, |
                                         SELF.DayWidth, |
                                         SELF.DayHeight)
  END
  SELF.SelectedBoxControl{PROP:Fill} = SELF.SelectedColor
  RETURN

hjCalendar.RenderDay PROCEDURE(LONG nDate, LONG nControl) !, PROTECTED, VIRTUAL
 CODE
  nControl{PROP:Flat} = True
  nControl{PROP:Trn} = True
  nControl{PROP:Skip} = True
  nControl{PROP:Text} = DAY(nDate)
  nControl{PROP:Hide} = False
  RETURN

hjCalendar.Reset PROCEDURE(BOOL Force = False) !, VIRTUAL
nDate                LONG,AUTO
nControl             LONG,AUTO
nCount               LONG,AUTO
 CODE
  IF SELF.ResetRequired() OR Force
    IF NOT SELF.RegionControl
      SELF.InitializeCalendar()
    END

    IF MONTH(SELF.DisplayDate) <> MONTH(SELF.SelectedDate) OR |
       YEAR(SELF.DisplayDate) <> YEAR(SELF.SelectedDate)
      LOOP nCount = 1 TO RECORDS(SELF.DayQueue)
        GET(SELF.DayQueue, nCount)
        DESTROY(SELF.DayQueue.Control)
      END
      FREE(SELF.DayQueue)
    END

    IF NOT RECORDS(SELF.DayQueue)
      nDate = DATE(MONTH(SELF.SelectedDate), 1, YEAR(SELF.SelectedDate))
      LOOP UNTIL MONTH(nDate) <> MONTH(SELF.SelectedDate)
        nControl = CREATE(0, CREATE:Button, SELF.GroupControl)
        SETPOSITION(nControl, SELF.GroupControl{PROP:Xpos} + (DayOfWeek(nDate) * SELF.DayWidth), |
                                           SELF.GroupControl{PROP:Ypos} + ((WeekOfMonth(nDate) + 2) * SELF.DayHeight), | ! The 2 accounts for the Month Prompt, and the Day Prompts
                                           SELF.DayWidth, |
                                           SELF.DayHeight)
        SELF.RenderDay(nDate, nControl)
        SELF.DayQueue.Control = nControl
        ADD(SELF.DayQueue)
        nControl += 1
        nDate += 1
      END
    END

    IF SELF.DisplayDate <> SELF.SelectedDate
      GET(SELF.DayQueue, DAY(SELF.SelectedDate))
      POST(EVENT:Accepted, SELF.DayQueue.Control)
    END
    SELF.DisplayDate = SELF.SelectedDate
    SELF.MonthNameControl{PROP:Text} = GetMonthName(MONTH(SELF.DisplayDate)) & ' ''' & SUB(YEAR(SELF.DisplayDate),3,2)

    SELF.TodayBoxControl{PROP:Hide} = CHOOSE(YEAR(TODAY()) <> YEAR(SELF.DisplayDate) OR MONTH(TODAY()) <> MONTH(SELF.DisplayDate))
    SELF.RefreshCalendar()
  END
  RETURN

hjCalendar.ResetRequired PROCEDURE() !, BOOL, VIRTUAL
bRet                 BOOL(False)
 CODE
  IF SELF.WindowOpened AND (NOT SELF.RegionControl OR SELF.SelectedDate <> SELF.DisplayDate)
    bRet = True
  END
  RETURN bRet

hjCalendar.SetAlerts PROCEDURE() !, VIRTUAL
 CODE
  SELF.GroupControl{PROP:Alrt} = MouseRightUp
  RETURN

hjCalendar.TakeDay PROCEDURE(LONG nDate) !, BYTE, PROTECTED, VIRTUAL
 CODE
  SELF.SelectedDate = nDate
  GET(SELF.DayQueue, DAY(nDate))
  SETPOSITION(SELF.SelectedBoxControl, SELF.DayQueue.Control{PROP:Xpos}, |
                                       SELF.DayQueue.Control{PROP:Ypos})
  RETURN LEVEL:Benign

hjCalendar.TakeDropDown PROCEDURE() !, BYTE, PRIVATE
nYear                SHORT, AUTO
nMonth               BYTE, AUTO
nPopup               BYTE, AUTO
 CODE
  nYear = YEAR(SELF.DisplayDate)
  nMonth = MONTH(SELF.DisplayDate)
  nPopup = SELF.DropDownControl{PROP:Selected}
  IF nPopup AND nPopup <> 4
    IF nMonth < 4 AND nPopup <= 4 - nMonth
      nYear -= 1
      nMonth = (nPopup + 9) + (nMonth - 1)
    ELSIF nMonth > 9 AND nPopup > 4 + (12 - nMonth)
      nYear += 1
      nMonth = (nPopup - 4) - (12 - nMonth)
    ELSE
      nMonth -= (4 - nPopup)
    END
    SELF.SelectedDate = DATE(nMonth, DAY(SELF.DisplayDate), nYear)
    SELF.Reset()
  END
  RETURN LEVEL:Benign

hjCalendar.TakeEvent PROCEDURE() !, BYTE, VIRTUAL
nAccepted            LONG,AUTO
nCount               LONG,AUTO
nRetval              BYTE(LEVEL:Benign)
 CODE
  CASE EVENT()
  OF EVENT:Accepted
    nAccepted = ACCEPTED()
    CASE nAccepted
    OF SELF.DropDownControl
      nRetval = SELF.TakeDropDown()
    OF SELF.MonthNameControl
      nRetval = SELF.TakeMonthName()
    OF SELF.NextMonthControl
      nRetval = SELF.TakeNextMonth()
    OF SELF.PrevMonthControl
      nRetval = SELF.TakePrevMonth()
    ELSE
      LOOP nCount = 1 TO RECORDS(SELF.DayQueue)
        GET(SELF.DayQueue, nCount)
        IF SELF.DayQueue.Control = nAccepted
          nRetval = SELF.TakeDay(DATE(MONTH(SELF.DisplayDate), nCount, YEAR(SELF.DisplayDate)))
          BREAK
        END
      END
    END
  OF EVENT:AlertKey
    IF FIELD(){PROP:Parent} = SELF.GroupControl
      CASE KEYCODE()
      OF MouseRightUp
        EXECUTE POPUP('Go to Today')
          BEGIN
            SELF.SelectedDate = TODAY()
            SELF.Reset()
          END
        END
      END
    END
  OF EVENT:OpenWindow
    SELF.WindowOpened = True
    SELF.Reset()
  OF EVENT:Sized
    SELF.RefreshCalendar()
  END
  RETURN nRetval

hjCalendar.TakeMonthName PROCEDURE() !, BYTE, PROTECTED, VIRTUAL
nYear                SHORT, AUTO
nMonth               BYTE, AUTO
nCount               LONG, AUTO
sPopup               STRING(200)
nPopup               BYTE, AUTO
 CODE
  nYear = YEAR(SELF.DisplayDate)
  nMonth = MONTH(SELF.DisplayDate)
  LOOP nCount = nMonth - 3 TO nMonth + 3
    IF nCount < 1
      sPopup = CLIP(sPopup) & GetMonthName(nCount + 12) & ' ' & (nYear - 1) & '|'
    ELSIF nCount > 12
      sPopup = CLIP(sPopup) & GetMonthName(nCount - 12) & ' ' & (nYear + 1) & '|'
    ELSE
      sPopup = CLIP(sPopup) & GetMonthName(nCount) & ' ' & nYear & '|'
    END
  END
  SELF.DropDownControl{PROP:Format} = CLIP(SELF.MonthNameControl{PROP:Width}) & 'C'
  SELF.DropDownControl{PROP:From} = SUB(sPopup, 1, LEN(CLIP(sPopup)) - 1)
  SELF.DropDownControl{PROP:Selected} = 4
  SELECT(SELF.DropDownControl)
  PRESSKEY(DownKey)
  RETURN LEVEL:Benign

hjCalendar.TakeNextMonth PROCEDURE() !, BYTE, PROTECTED, VIRTUAL
nYear                SHORT,AUTO
nMonth               BYTE,AUTO
 CODE
  nYear = YEAR(SELF.DisplayDate)
  nMonth = MONTH(SELF.DisplayDate) + 1
  IF nMonth = 13
    nMonth = 1
    nYear += 1
  END
  SELF.SelectedDate = DATE(nMonth, DAY(SELF.DisplayDate), nYear)
  SELF.Reset()
  RETURN LEVEL:Benign

hjCalendar.TakePrevMonth PROCEDURE() !, BYTE, PROTECTED, VIRTUAL
nYear                SHORT,AUTO
nMonth               BYTE,AUTO
 CODE
  nYear = YEAR(SELF.DisplayDate)
  nMonth = MONTH(SELF.DisplayDate) - 1
  IF nMonth = 0
    nMonth = 12
    nYear -= 1
  END
  SELF.SelectedDate = DATE(nMonth, DAY(SELF.DisplayDate), nYear)
  SELF.Reset()
  RETURN LEVEL:Benign
!------------------------------------------------------------------------------
hjCalendar.WindowComponent.Kill PROCEDURE()
 CODE
  SELF.Kill()
  RETURN

hjCalendar.WindowComponent.Reset PROCEDURE(BYTE Force)
 CODE
  SELF.Reset(Force)
  RETURN

hjCalendar.WindowComponent.ResetRequired PROCEDURE() !, BYTE
 CODE
  RETURN SELF.ResetRequired()

hjCalendar.WindowComponent.SetAlerts PROCEDURE()
 CODE
  SELF.SetAlerts()
  RETURN

hjCalendar.WindowComponent.TakeEvent PROCEDURE() !, BYTE
 CODE
  RETURN SELF.TakeEvent()

hjCalendar.WindowComponent.Update PROCEDURE()
 CODE
  RETURN

hjCalendar.WindowComponent.UpdateWindow PROCEDURE()
 CODE
  RETURN
